package ch.unige.solidify.util;

import org.springframework.boot.web.client.RestTemplateBuilder;
import org.springframework.context.annotation.Profile;
import org.springframework.stereotype.Component;

import ch.unige.solidify.service.HttpRequestInfoProvider;

@Profile({"client-backend", "test"})
@Component
public class BackendRestClientTool extends AbstractRestClientTool {

  private final HttpRequestInfoProvider httpRequestInfoProvider;

  public BackendRestClientTool(HttpRequestInfoProvider httpRequestInfoProvider) {
    this.httpRequestInfoProvider = httpRequestInfoProvider;
  }

  @Override
  protected RestTemplateBuilder addToken(RestTemplateBuilder restTemplateBuilder) {
    return this.addTokenFromRequest(restTemplateBuilder, this.httpRequestInfoProvider);
  }

}
