package ch.unige.solidify.util;

import javax.annotation.PostConstruct;

import org.springframework.beans.factory.annotation.Value;
import org.springframework.boot.web.client.RestTemplateBuilder;
import org.springframework.context.annotation.Profile;
import org.springframework.stereotype.Component;

import ch.unige.solidify.interceptor.BearerAuthorizationInterceptor;

@Profile("client-standalone")
@Component
public class StandaloneRestClientTool extends AbstractRestClientTool {

  private String accessToken;

  @Value("${solidify.oauth2.accesstoken:#{null}}")
  private String mainAccessToken;

  @PostConstruct
  public void init() {
    this.accessToken = this.mainAccessToken;
  }

  public StandaloneRestClientTool() {
    if (this.mainAccessToken == null) {
      this.mainAccessToken = System.getProperty("solidify.oauth2.accesstoken");
    }
  }

  @Override
  protected RestTemplateBuilder addToken(RestTemplateBuilder restTemplateBuilder) {
    return restTemplateBuilder.additionalInterceptors(new BearerAuthorizationInterceptor(this.accessToken));
  }

}
