package ch.unige.solidify.util;

import org.springframework.boot.web.client.RestTemplateBuilder;
import org.springframework.context.annotation.Profile;
import org.springframework.stereotype.Component;

@Profile({"client-backend", "test"})
@Component
public class TrustedRestClientTool extends AbstractRestClientTool {

  private String trustedToken;

  @Override
  protected RestTemplateBuilder addToken(RestTemplateBuilder restTemplateBuilder) {
    return this.addTrustedToken(restTemplateBuilder, this.trustedToken);
  }

  public void setTrustedToken(String trustedToken) {
    this.trustedToken = trustedToken;
  }

  public boolean hasTrustedToken() {
    return !StringTool.isNullOrEmpty(this.trustedToken);
  }

}
