package ch.unige.solidify.repository;

import javax.servlet.http.HttpServletRequest;

import org.springframework.boot.web.servlet.error.ErrorAttributes;
import org.springframework.dao.CannotAcquireLockException;
import org.springframework.dao.ConcurrencyFailureException;
import org.springframework.http.HttpStatus;
import org.springframework.orm.ObjectOptimisticLockingFailureException;

public class SolidifyDbLockError extends SolidifyError {

  boolean isOptimisticLock;

  public SolidifyDbLockError() {
  }

  public SolidifyDbLockError(ErrorAttributes errorAttributes, HttpServletRequest request,
          ConcurrencyFailureException e) {
    super(errorAttributes, request);
    if (e instanceof CannotAcquireLockException) {
      this.isOptimisticLock = false;
      this.setStatus(HttpStatus.PRECONDITION_FAILED);
    }
    if (e instanceof ObjectOptimisticLockingFailureException) {
      this.isOptimisticLock = true;
      this.setStatus(HttpStatus.PRECONDITION_FAILED);
    }
  }

  public boolean getOptimisticLock() {
    return this.isOptimisticLock;
  }

  public void setOptimisticLock(boolean optimisticLock) {
    this.isOptimisticLock = optimisticLock;
  }

}
