package ch.unige.solidify.rest;

import java.util.List;

/**
 * DTO used when managing a relation between 3 entity types through the Relation3TiersController
 *
 * @param <V> Type of the entity considered as the child when managing the relation through the Relation3TiersController
 * @param <W> Type of the entities considered as the grandchildren when managing the relation through the Relation3TiersController
 */
public interface Relation3TiersChildDTO<V extends Resource<V>, W extends Resource<W>> {

  <D extends JoinResourceContainer> List<D> getGrandChildren();
}
