package ch.unige.solidify.validation;

import java.util.ArrayList;
import java.util.List;

public class FieldValidationError {

  private List<String> errorMessages = new ArrayList<>();
  private String fieldName;
  private String code;

  public FieldValidationError() {

  }

  public FieldValidationError(String fieldName, String errorMessage) {
    this.fieldName = fieldName;
    this.errorMessages.add(errorMessage);
  }

  public FieldValidationError(String fieldName, String errorMessage, String code) {
    this.fieldName = fieldName;
    this.errorMessages.add(errorMessage);
    this.code = code;
  }

  public void addErrorMessage(String errorMessage) {
    this.errorMessages.add(errorMessage);
  }

  public void addErrorMessage(String errorMessage, String code) {
    this.errorMessages.add(errorMessage);
    this.code = code;
  }

  public List<String> getErrorMessages() {
    return this.errorMessages;
  }

  public String getFieldName() {
    return this.fieldName;
  }

  public void setErrorMessages(List<String> errorMessages) {
    this.errorMessages = errorMessages;
  }

  public void setFieldName(String fieldName) {
    this.fieldName = fieldName;
  }

  public String getCode() {
    return code;
  }

  public void setCode(String code) {
    this.code = code;
  }

}
