package ch.unige.solidify.test.util;

import static org.junit.jupiter.api.Assertions.assertArrayEquals;

import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;

import org.junit.jupiter.api.Test;
import org.junit.jupiter.api.extension.ExtendWith;
import org.springframework.core.io.ClassPathResource;
import org.springframework.test.context.junit.jupiter.SpringExtension;

import ch.unige.solidify.util.FileTool;

@ExtendWith(SpringExtension.class)
class FileToolTest {
  @Test
  void testCopy() throws IOException {
    final Path sourcePath = new ClassPathResource("xslt/datacite2oai_dc.xsl").getFile().toPath();
    final Path destPath = Paths.get(System.getProperty("java.io.tmpdir"),"tmpFile");
    FileTool.copyFile(sourcePath, destPath);
    assertArrayEquals(Files.readAllBytes(sourcePath), Files.readAllBytes(destPath));
  }
}
